#ifndef SW_CHECK_H
#define SW_CHECK_H

/**
 * Copyright (C) 2006 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "request.h"
#include "caseX.h"

/**
 * these are the filtering functions of squidwall
 */
extern int check_redirect(request_t *r);
extern int check_blist(request_t *r);
extern int check_wlist(request_t *r);
extern int check_banner(request_t *r);
extern int check_cont(request_t *r);

/**
 * getting the acl's for users/hosts/globals right
 */
extern int get_acl_host(request_t *r);
extern int get_acl_user(request_t *r);
extern int get_acl_global(request_t *r);
extern int get_acls(request_t *r);

/**
 * clamav scanning routines
 */
extern int check_clamav_connect(request_t *r);
extern int check_clamav_checkresult(request_t *r);
extern void check_clamav_put2stream(request_t *r, char ch);

#endif
