
/**
 * Copyright (C) 2006 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * debug section: 15 (global acl checking)
 */

#include "squidwall.h"

/**
 * 
 */
int get_acl_global(request_t *r)
{
	struct squidwall_acl *acl;
	struct list_head *l;

	/* initialize the stralloc pointers */
	r->bf_global.ufilter=0;
	r->bf_global.ufilter_url=0;
	r->bf_global.ufilter_dom=0;
	r->bf_global.ufilter_md5=0;
	r->bf_global.ufilter_sha1=0;
	r->bf_global.urfilter=0;

	r->uf_global.ufilter=0;
	r->uf_global.ufilter_url=0;
	r->uf_global.ufilter_dom=0;
	r->uf_global.ufilter_md5=0;
	r->uf_global.ufilter_sha1=0;
	r->uf_global.urfilter=0;

	r->wf_global.ufilter=0;
	r->wf_global.ufilter_url=0;
	r->wf_global.ufilter_dom=0;
	r->wf_global.ufilter_md5=0;
	r->wf_global.ufilter_sha1=0;
	r->wf_global.urfilter=0;

	r->cf_global.pfilter=0;
	r->cf_global.cfilter=0;
	r->cf_global.crfilter=0;
	r->cf_global.bcfilter=0;

	list_for_each(l, &globals) {
		acl = list_entry(l, struct squidwall_acl, list);
		if (!acl) {
			debug(15,3, "warning, no global acl defined!");
		}

		r->bf_global.ufilter      = &acl->bfilter;
		r->bf_global.ufilter_url  = &acl->bfilter_url;
		r->bf_global.ufilter_dom  = &acl->bfilter_dom;
		r->bf_global.ufilter_md5  = &acl->bfilter_md5;
		r->bf_global.ufilter_sha1 = &acl->bfilter_sha1;
		r->bf_global.urfilter     = &acl->brfilter;

		r->uf_global.ufilter      = &acl->wfilter;
		r->uf_global.ufilter_url  = &acl->wfilter_url;
		r->uf_global.ufilter_dom  = &acl->wfilter_dom;
		r->uf_global.ufilter_md5  = &acl->wfilter_md5;
		r->uf_global.ufilter_sha1 = &acl->wfilter_sha1;
		r->uf_global.urfilter     = &acl->wrfilter;

		r->wf_global.ufilter      = &acl->ufilter;
		r->wf_global.ufilter_url  = &acl->ufilter_url;
		r->wf_global.ufilter_dom  = &acl->ufilter_dom;
		r->wf_global.ufilter_md5  = &acl->ufilter_md5;
		r->wf_global.ufilter_sha1 = &acl->ufilter_sha1;
		r->wf_global.urfilter     = &acl->urfilter;

		r->cf_global.pfilter  = &acl->pfilter;
		r->cf_global.cfilter  = &acl->cfilter;
		r->cf_global.crfilter = &acl->crfilter;
		r->cf_global.bcfilter = &acl->bcfilter;

		set(r->todo, acl->todo);
		return acl->flags;
	}

	return ACL_NONE;
}
