
/**
 * Copyright (C) 2005-2006 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * debug section: 13 (user acl checking)
 */

#include "squidwall.h"

/**
 * 
 */
int get_acl_user(request_t *r)
{
	struct squidwall_acl *acl;
	struct list_head *l;
	int found;

	/* initialize the stralloc pointers */
	r->bf_user.ufilter=0;
	r->bf_user.ufilter_url=0;
	r->bf_user.ufilter_dom=0;
	r->bf_user.ufilter_md5=0;
	r->bf_user.ufilter_sha1=0;
	r->bf_user.urfilter=0;

	r->uf_user.ufilter=0;
	r->uf_user.ufilter_url=0;
	r->uf_user.ufilter_dom=0;
	r->uf_user.ufilter_md5=0;
	r->uf_user.ufilter_sha1=0;
	r->uf_user.urfilter=0;

	r->wf_user.ufilter=0;
	r->wf_user.ufilter_url=0;
	r->wf_user.ufilter_dom=0;
	r->wf_user.ufilter_md5=0;
	r->wf_user.ufilter_sha1=0;
	r->wf_user.urfilter=0;

	list_for_each(l, &users) {
		acl = list_entry(l, struct squidwall_acl, list);
		found = 0;

		/* check the username */
		if (case_equals(acl->filename.s, r->user.s)) {
			debug(13,3, "@check_user(%s) ", r->user.s);
			found = 1;
		}

		if (!found) continue;

		r->bf_user.ufilter      = &acl->bfilter;
		r->bf_user.ufilter_url  = &acl->bfilter_url;
		r->bf_user.ufilter_dom  = &acl->bfilter_dom;
		r->bf_user.ufilter_md5  = &acl->bfilter_md5;
		r->bf_user.ufilter_sha1 = &acl->bfilter_sha1;
		r->bf_user.urfilter     = &acl->brfilter;

		r->uf_user.ufilter      = &acl->wfilter;
		r->uf_user.ufilter_url  = &acl->wfilter_url;
		r->uf_user.ufilter_dom  = &acl->wfilter_dom;
		r->uf_user.ufilter_md5  = &acl->wfilter_md5;
		r->uf_user.ufilter_sha1 = &acl->wfilter_sha1;
		r->uf_user.urfilter     = &acl->wrfilter;

		r->wf_user.ufilter      = &acl->ufilter;
		r->wf_user.ufilter_url  = &acl->ufilter_url;
		r->wf_user.ufilter_dom  = &acl->ufilter_dom;
		r->wf_user.ufilter_md5  = &acl->ufilter_md5;
		r->wf_user.ufilter_sha1 = &acl->ufilter_sha1;
		r->wf_user.urfilter     = &acl->urfilter;

		r->cf_user.pfilter  = &acl->pfilter;
		r->cf_user.cfilter  = &acl->cfilter;
		r->cf_user.crfilter = &acl->crfilter;
		r->cf_user.bcfilter = &acl->bcfilter;

		set(r->todo, acl->todo);
		return acl->flags;
	}

	return ACL_NONE;
}
