#ifndef LOG_H
#define LOG_H

/**
 * Copyright (C) 2005-2006 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/* system */
#include <unistd.h>

/* squidwall */
#include "request.h"
#include "debug.h"

extern void log_init(request_t *r, int reinit);
extern void log_timestamp(request_t *r);
extern void log_s(request_t *r, char *s);
extern void log_sa(request_t *r, stralloc *sa);
extern void log_flush(request_t *r);
extern void log_u32pw(request_t *r, const unsigned long u, const unsigned int pad, const char with);
extern void log_pid(request_t *r);
extern void log_wid(request_t *r);
extern void log_headline(request_t *r, char *headline);

/* wrapper for write, we use a mutex here! */
extern int log_write(int fd, char *s, unsigned int len);

#endif
