#ifndef SW_READ_ACLS_H
#define SW_READ_ACLS_H

/**
 * Copyright (C) 2006 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/* squidwall */
#include "request.h"

/**
 * read_acls - read the acl directories
 */
extern void read_acls(request_t *r);

/**
 * array's of type struct squidwall_regex
 */
extern array array_cfilter_todo;
extern array array_pfilter_todo;

/* lists with all defined hosts/users/redirects */
extern struct list_head hosts;
extern struct list_head users;
extern struct list_head globals;
extern struct list_head redirects;

/* lists with all defined filters */
extern struct list_head bfilter;
extern struct list_head brfilter;
extern struct list_head bfilter_url;
extern struct list_head bfilter_dom;
extern struct list_head bfilter_md5;
extern struct list_head bfilter_sha1;

extern struct list_head ufilter;
extern struct list_head urfilter;
extern struct list_head ufilter_url;
extern struct list_head ufilter_dom;
extern struct list_head ufilter_md5;
extern struct list_head ufilter_sha1;

extern struct list_head wfilter;
extern struct list_head wrfilter;
extern struct list_head wfilter_url;
extern struct list_head wfilter_dom;
extern struct list_head wfilter_md5;
extern struct list_head wfilter_sha1;

extern struct list_head pfilter;
extern struct list_head cfilter;
extern struct list_head crfilter;
extern struct list_head bcfilter;

#endif
