#ifndef SW_READ_CONTROLS_H
#define SW_READ_CONTROLS_H

/**
 * Copyright (C) 2006 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <sys/time.h>
#include <time.h>

#include "squidwall.h"

extern int read_controls(request_t *r);

struct ip_address {
	unsigned char d[4];
};

extern char *proxy;
extern char *logfile;
extern char *host_dir;
extern char *user_dir;
extern char *cache_dir;
extern char *redir_dir;
extern char *globals_dir;
extern char *clamav_tcp;
extern char *clamav_socket;

extern int cache;
extern int maxsize;
extern int memcache;
extern int pfilter_max;
extern int pfilter_default;
extern int sqlite_timeout;

extern struct ip_address clamd_ip;
extern struct ip_address proxy_ip;

extern unsigned clamd_port;
extern unsigned clams_port;
extern unsigned proxy_port;

extern char *redir_badurl;
extern char *redir_badcont;
extern char *redir_baduser;
extern char *redir_badhost;
extern char *redir_safesite;
extern char *redir_virusfound;
extern char *redir_bannerfound;
extern char *redir_webinterface;

extern char *bfilter_dir;
extern char *brfilter_dir;
extern char *bfilter_url_dir;
extern char *bfilter_dom_dir;
extern char *bfilter_md5_dir;
extern char *bfilter_sha1_dir;

extern char *ufilter_dir;
extern char *urfilter_dir;
extern char *ufilter_url_dir;
extern char *ufilter_dom_dir;
extern char *ufilter_md5_dir;
extern char *ufilter_sha1_dir;

extern char *wfilter_dir;
extern char *wrfilter_dir;
extern char *wfilter_url_dir;
extern char *wfilter_dom_dir;
extern char *wfilter_md5_dir;
extern char *wfilter_sha1_dir;

extern char *pfilter_dir;
extern char *cfilter_dir;
extern char *crfilter_dir;
extern char *bcfilter_dir;

/**
 * level: 1|2|4|8|16|32|64|128|256 ;
 * section: 1..MAX_SECTION
 */
extern unsigned int debugging[];

#endif
