#ifndef SW_THREAD_H
#define SW_THREAD_H

/**
 * Copyright (C) 2006 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "request.h"

/**
 * the threadpool is not useable yet!
 */
#define THREADPOOL 0

/**
 * this structure is for passing work to a squidwall thread
 */
struct squidwall_work {
	void (*fn)(request_t *r); /* callback function */
#if THREADPOOL
	struct list_head list;    /* when idle, on squidwall_idle_list */
	int nr;                   /* worker number */
#endif
};

/**
 * thread_init() - init the threading
 */
extern void thread_init(void);

/**
 * thread_operation() - give a thread some work
 */
extern int thread_operation(void (*fn)(request_t *r));

#endif /* SW_THREAD_H */
